/*{
    "CATEGORIES": [
        "Automatically Converted",
        "GLSLSandbox"
    ],
    "CREDIT": null,
    "DESCRIPTION": "Automatically converted from http://glslsandbox.com/e#48946.0",
    "INPUTS": [
        {
            "DEFAULT": 0.5,
            "LABEL": "Rotation",
            "MAX": 3,
            "MIN": 0,
            "NAME": "Rotation",
            "TYPE": "float"
        },
        {
            "DEFAULT": 0.4,
            "LABEL": "Red",
            "MAX": 1,
            "MIN": 0,
            "NAME": "Red",
            "TYPE": "float"
        },
        {
            "DEFAULT": 0,
            "LABEL": "Green",
            "MAX": 1,
            "MIN": 0,
            "NAME": "Green",
            "TYPE": "float"
        },
        {
            "DEFAULT": 0.7,
            "LABEL": "Blue",
            "MAX": 1,
            "MIN": 0,
            "NAME": "Blue",
            "TYPE": "float"
        },
        {
            "DEFAULT": 0,
            "LABEL": "Color Highlight",
            "MAX": 0.9,
            "MIN": 0,
            "NAME": "ColorHighlight",
            "TYPE": "float"
        },
        {
            "DEFAULT": 1,
            "LABEL": "Distortion",
            "MAX": 10,
            "MIN": 0.1,
            "NAME": "Distortion",
            "TYPE": "float"
        },
        {
            "DEFAULT": 0,
            "LABEL": "Shape",
            "MAX": 5,
            "MIN": 0,
            "NAME": "Shape",
            "TYPE": "float"
        }
    ],
    "ISFVSN": "2",
    "VSN": null
}
*/


#ifdef GL_ES
precision mediump float;
#endif

#extension GL_OES_standard_derivatives : enable


mat2 rotate(float a) {
	float c = cos(a), s = sin(a);
	return mat2(c, -s, s, c);
}

void main() {
	vec2 uv = (2.* gl_FragCoord.xy - RENDERSIZE) / RENDERSIZE.y;
	vec3 color = vec3(ColorHighlight);
	uv *= rotate(TIME * Rotation);
	uv = abs(uv)+Shape;
	vec2 ar = vec2(sin(atan(uv.x, uv.y)*Distortion), length(uv));
	color -= mix(color, vec3(Red, Green, Blue), tan(8. * sin(ar.y * 1. - TIME*0.5) + TIME*0.5) + sin(8. * ar.x - 8. * ar.y));
	//color /= mix(color, vec3(.7, .2, 0.), cos(8. ) + tan(5. * ar.y - 8. * ar.x));	
	gl_FragColor = vec4(color, 1.);
}